//
// PropertyAPI.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

open class PropertyAPI {

    /**
     Compare property by id to local area
     
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func calculateLocalGraph(id: Int, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Void?, _ error: Error?) -> Void)) -> RequestTask {
        return calculateLocalGraphWithRequestBuilder(id: id, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case .success:
                completion((), nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Compare property by id to local area
     - GET /Property/{id}/calculateLocalGraph
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - returns: RequestBuilder<Void> 
     */
    open class func calculateLocalGraphWithRequestBuilder(id: Int, filter: String? = nil) -> RequestBuilder<Void> {
        var localVariablePath = "/Property/{id}/calculateLocalGraph"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "filter": filter?.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Void>.Type = OpenAPIClientAPI.requestBuilderFactory.getNonDecodableBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Calculate Foyer Score for Property
     
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func calculateScore(id: Int, filter: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: CalculateScore200Response?, _ error: Error?) -> Void)) -> RequestTask {
        return calculateScoreWithRequestBuilder(id: id, filter: filter).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Calculate Foyer Score for Property
     - GET /Property/{id}/calculateScore
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - returns: RequestBuilder<CalculateScore200Response> 
     */
    open class func calculateScoreWithRequestBuilder(id: Int, filter: String? = nil) -> RequestBuilder<CalculateScore200Response> {
        var localVariablePath = "/Property/{id}/calculateScore"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        let localVariableUrlComponents = URLComponents(string: localVariableURLString)

        let localVariableNillableHeaders: [String: Any?] = [
            "filter": filter?.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<CalculateScore200Response>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Find Nearest Properties
     
     - parameter streetNumber: (query)  
     - parameter street: (query)  
     - parameter streetType: (query)  
     - parameter cityName: (query)  
     - parameter state: (query)  
     - parameter lat: (query)  
     - parameter lng: (query)  
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func findNearestProperties(streetNumber: String, street: String, streetType: String, cityName: String, state: String, lat: Double, lng: Double, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: FindNearestProperties200Response?, _ error: Error?) -> Void)) -> RequestTask {
        return findNearestPropertiesWithRequestBuilder(streetNumber: streetNumber, street: street, streetType: streetType, cityName: cityName, state: state, lat: lat, lng: lng).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Find Nearest Properties
     - GET /Property/findNearest
     - Provide an address to find the geographically closest Properties
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter streetNumber: (query)  
     - parameter street: (query)  
     - parameter streetType: (query)  
     - parameter cityName: (query)  
     - parameter state: (query)  
     - parameter lat: (query)  
     - parameter lng: (query)  
     - returns: RequestBuilder<FindNearestProperties200Response> 
     */
    open class func findNearestPropertiesWithRequestBuilder(streetNumber: String, street: String, streetType: String, cityName: String, state: String, lat: Double, lng: Double) -> RequestBuilder<FindNearestProperties200Response> {
        let localVariablePath = "/Property/findNearest"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "streetNumber": (wrappedValue: streetNumber.encodeToJSON(), isExplode: true),
            "street": (wrappedValue: street.encodeToJSON(), isExplode: true),
            "streetType": (wrappedValue: streetType.encodeToJSON(), isExplode: true),
            "cityName": (wrappedValue: cityName.encodeToJSON(), isExplode: true),
            "state": (wrappedValue: state.encodeToJSON(), isExplode: true),
            "lat": (wrappedValue: lat.encodeToJSON(), isExplode: true),
            "lng": (wrappedValue: lng.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<FindNearestProperties200Response>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Find One Property
     
     - parameter filter: (header)  
     - parameter verbosity: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func findOneProperty(filter: String, verbosity: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Property?, _ error: Error?) -> Void)) -> RequestTask {
        return findOnePropertyWithRequestBuilder(filter: filter, verbosity: verbosity).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Find One Property
     - GET /Property/findOne
     - Find one Property according to defined filter criteria. Also allows for verbosity parameter to shortcut commonly used filters
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter filter: (header)  
     - parameter verbosity: (query)  (optional)
     - returns: RequestBuilder<Property> 
     */
    open class func findOnePropertyWithRequestBuilder(filter: String, verbosity: String? = nil) -> RequestBuilder<Property> {
        let localVariablePath = "/Property/findOne"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "verbosity": (wrappedValue: verbosity?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            "filter": filter.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Property>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Properties
     
     - parameter filter: (header)  (optional)
     - parameter verbosity: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func getProperties(filter: String? = nil, verbosity: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: GetProperties200Response?, _ error: Error?) -> Void)) -> RequestTask {
        return getPropertiesWithRequestBuilder(filter: filter, verbosity: verbosity).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Properties
     - GET /Property
     - Get an object with an array of properties and a total count according to defined filter criteria. Also allows for verbosity parameter to shortcut commonly used filters
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter filter: (header)  (optional)
     - parameter verbosity: (query)  (optional)
     - returns: RequestBuilder<GetProperties200Response> 
     */
    open class func getPropertiesWithRequestBuilder(filter: String? = nil, verbosity: String? = nil) -> RequestBuilder<GetProperties200Response> {
        let localVariablePath = "/Property"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "verbosity": (wrappedValue: verbosity?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            "filter": filter?.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<GetProperties200Response>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Property by Id
     
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - parameter verbosity: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func getPropertyById(id: Int, filter: String? = nil, verbosity: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Property?, _ error: Error?) -> Void)) -> RequestTask {
        return getPropertyByIdWithRequestBuilder(id: id, filter: filter, verbosity: verbosity).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Property by Id
     - GET /Property/{id}
     - Get specific Property with unique id. Also allows for verbosity parameter to shortcut commonly used filters
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter id: (path)  
     - parameter filter: (header)  (optional)
     - parameter verbosity: (query)  (optional)
     - returns: RequestBuilder<Property> 
     */
    open class func getPropertyByIdWithRequestBuilder(id: Int, filter: String? = nil, verbosity: String? = nil) -> RequestBuilder<Property> {
        var localVariablePath = "/Property/{id}"
        let idPreEscape = "\(APIHelper.mapValueToPathItem(id))"
        let idPostEscape = idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        localVariablePath = localVariablePath.replacingOccurrences(of: "{id}", with: idPostEscape, options: .literal, range: nil)
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "verbosity": (wrappedValue: verbosity?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            "filter": filter?.encodeToJSON(),
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Property>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Gets a property by a viewer key
     
     - parameter viewerKey: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func getPropertyByViewerKey(viewerKey: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: Property?, _ error: Error?) -> Void)) -> RequestTask {
        return getPropertyByViewerKeyWithRequestBuilder(viewerKey: viewerKey).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Gets a property by a viewer key
     - GET /Property/propertyByViewerKey
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter viewerKey: (query)  (optional)
     - returns: RequestBuilder<Property> 
     */
    open class func getPropertyByViewerKeyWithRequestBuilder(viewerKey: String? = nil) -> RequestBuilder<Property> {
        let localVariablePath = "/Property/propertyByViewerKey"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "viewerKey": (wrappedValue: viewerKey?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<Property>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Get Recommendations
     
     - parameter limit: (query)  (optional)
     - parameter bufLen: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func getRecommendations(limit: Int? = nil, bufLen: Int? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [Property]?, _ error: Error?) -> Void)) -> RequestTask {
        return getRecommendationsWithRequestBuilder(limit: limit, bufLen: bufLen).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Get Recommendations
     - GET /Property/getRecommendations
     - Return an array of Properties according to preferences set on User and Shopper Models
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter limit: (query)  (optional)
     - parameter bufLen: (query)  (optional)
     - returns: RequestBuilder<[Property]> 
     */
    open class func getRecommendationsWithRequestBuilder(limit: Int? = nil, bufLen: Int? = nil) -> RequestBuilder<[Property]> {
        let localVariablePath = "/Property/getRecommendations"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "limit": (wrappedValue: limit?.encodeToJSON(), isExplode: true),
            "bufLen": (wrappedValue: bufLen?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[Property]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }

    /**
     Property Search
     
     - parameter verbosity: (query)  (optional)
     - parameter apiResponseQueue: The queue on which api response is dispatched.
     - parameter completion: completion handler to receive the data and the error objects
     */
    @discardableResult
    open class func propertySearch(verbosity: String? = nil, apiResponseQueue: DispatchQueue = OpenAPIClientAPI.apiResponseQueue, completion: @escaping ((_ data: [Property]?, _ error: Error?) -> Void)) -> RequestTask {
        return propertySearchWithRequestBuilder(verbosity: verbosity).execute(apiResponseQueue) { result in
            switch result {
            case let .success(response):
                completion(response.body, nil)
            case let .failure(error):
                completion(nil, error)
            }
        }
    }

    /**
     Property Search
     - GET /Property/search
     - Search for properties according to defined criteria and desired image features
     - BASIC:
       - type: http
       - name: bearerAuth
     - parameter verbosity: (query)  (optional)
     - returns: RequestBuilder<[Property]> 
     */
    open class func propertySearchWithRequestBuilder(verbosity: String? = nil) -> RequestBuilder<[Property]> {
        let localVariablePath = "/Property/search"
        let localVariableURLString = OpenAPIClientAPI.basePath + localVariablePath
        let localVariableParameters: [String: Any]? = nil

        var localVariableUrlComponents = URLComponents(string: localVariableURLString)
        localVariableUrlComponents?.queryItems = APIHelper.mapValuesToQueryItems([
            "verbosity": (wrappedValue: verbosity?.encodeToJSON(), isExplode: true),
        ])

        let localVariableNillableHeaders: [String: Any?] = [
            :
        ]

        let localVariableHeaderParameters = APIHelper.rejectNilHeaders(localVariableNillableHeaders)

        let localVariableRequestBuilder: RequestBuilder<[Property]>.Type = OpenAPIClientAPI.requestBuilderFactory.getBuilder()

        return localVariableRequestBuilder.init(method: "GET", URLString: (localVariableUrlComponents?.string ?? localVariableURLString), parameters: localVariableParameters, headers: localVariableHeaderParameters, requiresAuthentication: true)
    }
}
